#! /usr/local/bin/perl

################################################
#BooEasyCalendar v1.36 / This program is free. #
#(C) BooBooClub 1999-2008                      #
################################################


#set data
$dat = './hd.dat';
$sdat = './shd.dat';
$html = './calendar.html';
$size = '3';
$yb = 'off';
$mb = 'on';
$yclr = '#888888';
$mclr = '#888888';
$dclr = '#000000';
$eclr = '#0000bb';
$hclr = '#ff0000';
$sclr = '#ff00ff';
$tset = 'border cellpadding="5" bordercolor="#008800" style="border-collapse:collapse;width:180px;"';
$mset = 'align="center"';
$dset = 'align="center"';
$eset = 'bgcolor="#eeeeff" align="center"';
$hset = 'bgcolor="#ffeeee" align="center"';
$sset = 'bgcolor="#ffeeff" align="center"';
$prny = 'on';
$prnm = 'on';
$yert = 'N@';
$mont = '';
$week = ',,,,,,y';
$tts = 'b';



#TimeZone
$ENV{'TZ'}='JST-9';

#read
if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}



#branch

&ready;
&output;
exit 0;



sub ready{
	#ready

	open (HTML,"$html");
	@html = <HTML>;
	close (HTML);

	open (DAT,"$dat");
	@dats = <DAT>;
	close (DAT);

	open (SDAT,"$sdat");
	@sdats = <SDAT>;
	close (SDAT);
}



sub output{
	#output
	print "Content-type: text/html\n\n";

	$ohtml = join('',@html);
	@chtml = split(/(<!--bec[\+-]?\d*?-->)|(bec\.cgi\?m=[\+-]?\d*)/,$ohtml);

	foreach $chtml(@chtml){
		if($chtml =~ /<!--bec([\+-]?\d*?)-->/){
			$param = $1;
			$FORM{'m'} =~ s/[^\+\-\d]//g;
			$param += $FORM{'m'};
			&cal;
			print "$ecal";
		}
		else{
			if($FORM{'m'} && $chtml =~ /bec\.cgi\?m=([\+-]?\d*)/){
				$nm = $1;
				$m = $FORM{'m'};
				$nm += $m;
				if($nm > 0){
					$nm = '+'.$nm;
				}
				if($nm > 24){
					$nm = "+24";
				}
				elsif($nm < -24){
					$nm = "-24";
				}
				$chtml =~ s/bec\.cgi\?m=([\+-]?)\d*/bec\.cgi\?m=$nm/i;
			}
			print "$chtml";
		}
	}
}



sub cal{
	#time
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$year += 1900;

	#set time
	if($FORM{'m'} eq ''){
		$FORM{'m'} = '0';
	}

	if($FORM{'m'} >= 0){
		if(($mon + $param) / 12 < 0){
			$yrf = (int(($mon + $param) * -1 / 12)+1) * -1;
			if((($mon + $param) * -1)%12 == 0){
				$yrf++;
			}
		}
		else{
			$yrf = int(($mon + $param) / 12);
		}
	}
	elsif($FORM{'m'} < 0){
		$yrf = int(($mon + $param - 11) / 12);
	}

	$year += $yrf;
	$mon = ($mon + $param) % 12;
	$mon++;
	$ryear = $year;
	$rmon = $mon;


	#other month
	if($param ne ''){
		$mday = 3;
		if ($mon == 1 || $mon == 2){
			$year--;
			$mon += 12;
		}
		$wday = int($year+int($year/4)-int($year/100)+int($year/400)+int((13*$mon+8)/5)+$mday)%7;
	}
	$year = $ryear;
	$mon = $rmon;


	#ready
	$ptfd = ($mday % 7);
	if($ptfd == 0){
		$ptfd = 7;
	}
	$mfd = ((($wday + 7) - ($ptfd - 1)) % 7);


	if($mon == 2){
		if(($year % 4) == 0 && !((($year % 100) == 0) && (($year % 400) != 0))){
			@d = (1..29);
		}
		else{
			@d = (1..28);
		}
	}
	elsif($mon == 4||$mon == 6||$mon == 9||$mon == 11){
		@d = (1..30);
	}
	else{
		@d = (1..31);
	}
	$lastday = @d;

	foreach $hd(@dats){
		chomp $hd;
		($md,$dd,$wd) = split(/\//, $hd);
		if($mon == $md){
			if($wd){
				$nd = (($dd * 7) - $mfd + ($wd + 1));
				$dd = $nd;
				if($wd >= $mfd){
					$dd = $dd - 7;
				}
			}
			elsif($dd =~ /\D/){
				if($dd eq 'VED'){
					$dd = int(20.8431+0.242194*($year-1980)-int(($year-1980)/4));
				}
				elsif($dd eq 'AED'){
					$dd = int(23.2488+0.242194*($year-1980)-int(($year-1980)/4));
				}
			}
			if((($mfd - 1 + $dd) % 7) == 0){
				$ddt = $dd + 1;
				if($dd <= $lastday){
					$d[$dd] = 'h<font size="'."$size".'" color="'."$hclr".'">'."$ddt".'</font>';
				}
			}
			else{
				$dd += 0;
				if($dd <= $lastday){
					$d[$dd-1] = 'h<font size="'."$size".'" color="'."$hclr".'">'."$dd".'</font>';
				}
			}
		}
	}


	foreach $shd(@sdats){
		chomp $shd;
		if($shd =~ /,/){
			($shdid,$shdclr,$shdbackc) = split(/,/,$shd);
			if($shdclr eq ''){
				$shdclr = $sclr;
			}
			if($shdbackc eq ''){
				$shdbackc = $sset;
			}
		}
		else{
			$shdclr = $sclr;
			$shdbackc = $sset;
			$shdid = $shd;
		}
		($syd,$smd,$sdd) = split(/\//, $shdid);
		if($year == $syd && $mon == $smd){
			chomp $sdd;
			$sdd += 0;
			if($sdd <= $lastday){
				$d[$sdd-1] = 's'."$shdbackc".'###'.'<font size="'."$size".'" color="'."$shdclr".'">'."$sdd".'</font>';
			}
		}
	}

	while($mfd > 0){
		unshift (@d, '');
		$mfd--;
	}

	$cnt_d = @d;
	$mtd = 7-($cnt_d % 7);
	while($mtd > 0){
		push (@d, '');
		$mtd--;
	}


	@week = split(/,/, $week);


	#cal html
	$ecal = '';
	$ecal .= '<table '."$tset".'>'."\n";
	if($prny eq 'on'){
		$py = $year;
	}
	else{
		$py = '';
		$yert = '';
	}
	if($prnm eq 'on'){
		$pm = $mon;
	}
	else{
		$pm = '';
		$mont = '';
	}

	if($yb eq 'on'){
		$yb1 = '<b>';
		$yb2 = '</b>';
	}
	if($mb eq 'on'){
		$mb1 = '<b>';
		$mb2 = '</b>';
	}
	$ecal .= '<tr><td colspan="7" '."$mset".'><center><font size="'."$size".'" color="'."$yclr".'">'."$yb1"."$py"."$yert"."$yb2".'</font><font size="'."$size".'" color="'."$mclr".'">'."$mb1"."$pm"."$mont"."$mb2".'</font></center></td></tr>'."\n";

	if($week ne ''){
		$ecal .= '<tr>';
		$ecal .= '<td '."$hset".'><font size="'."$size".'" color="'."$hclr".'">'."$week[0]".'</font></td>';
		$ecal .= '<td '."$dset".'><font size="'."$size".'" color="'."$dclr".'">'."$week[1]".'</font></td>';
		$ecal .= '<td '."$dset".'><font size="'."$size".'" color="'."$dclr".'">'."$week[2]".'</font></td>';
		$ecal .= '<td '."$dset".'><font size="'."$size".'" color="'."$dclr".'">'."$week[3]".'</font></td>';
		$ecal .= '<td '."$dset".'><font size="'."$size".'" color="'."$dclr".'">'."$week[4]".'</font></td>';
		$ecal .= '<td '."$dset".'><font size="'."$size".'" color="'."$dclr".'">'."$week[5]".'</font></td>';
		$ecal .= '<td '."$eset".'><font size="'."$size".'" color="'."$eclr".'">'."$week[6]".'</font></td>';
		$ecal .= '</tr>'."\n";
	}

	$ecal .= '<tr>';
	$i = 0;


	foreach $ed(@d){
		$i++;

		if($ed eq ''){
			$ed = '&nbsp;';
		}

		@nowdate = localtime(time);
		$nowdate[5] += 1900;
		$nowdate[4]++;
		$nowdate[3] += 0;
		if($tts eq 'b' && $nowdate[5] == $py && $nowdate[4] == $mon && $nowdate[3] == $ed){
			$ed = '<b>'.$ed.'</b>';
		}
		if($ed =~ /^s/){
			$ed =~ s/^s//;
			($shdbackc,$ed) = split(/###/,$ed);
			if($shdbackc eq ''){
				$shdbackc = $sset;
			}
			if($shdbackc =~ /^#/){
				$tmpshdb = $sset;
				if($tmpshdb =~ /#\w\w\w\w\w\w/){
					$tmpshdb =~ s/#\w\w\w\w\w\w/$shdbackc/;
					$shdbackc .= ' '.$tmpshdb;
				}
				else{
					$shdbackc = 'bgcolor="'.$shdbackc.'"';
				}
			}
			$ecal .= '<td '."$shdbackc".'>'."$ed".'</td>';
		}
		elsif($ed =~ /^h/){
			$ed =~ s/^h//;
			$ecal .= '<td '."$hset".'><font size="'."$size".'" color="'."$sclr".'">'."$ed".'</font></td>';
		}
		elsif($i == 1 && $ed !~ /font/i){
			$ecal .= '<td '."$hset".'><font size="'."$size".'" color="'."$hclr".'">'."$ed".'</font></td>';
		}
		elsif($i == 1 && $ed =~ /font/i){
			$ecal .= '<td '."$dset".'>'."$ed".'</td>';
		}
		elsif($i == 7 && $ed !~ /font/i){
			$ecal .= '<td '."$eset".'><font size="'."$size".'" color="'."$eclr".'">'."$ed".'</font></td>';
		}
		elsif($i == 7 && $ed =~ /font/i){
			$ecal .= '<td '."$dset".'>'."$ed".'</td>';
		}
		else{
			if($ed !~ /font/i){
				$ecal .= '<td '."$dset".'><font size="'."$size".'" color="'."$dclr".'">'."$ed".'</font></td>';
			}
			elsif($ed =~ /font/i){
				$ecal .= '<td '."$dset".'>'."$ed".'</td>';
			}
		}
		if($i == 7){
			$ecal .= '</tr>'."\n";
			$ecal .= '<tr>';
			$i = 0;
		}
	}
	$ecal .= '</tr>'."\n".'</table>'."\n";

	$ecal =~ s/ >/>/g;
	$ecal =~ s/(<font[^>]+?>)(<font[^>]+?>)/$2/ig;
	$ecal =~ s/<\/font><\/font>/<\/font>/ig;
	$ecal =~ s/<tr><\/tr>//ig;
}

